#include "mbed.h"
#include "MQTTESP8266.h"
#include "MQTTClient.h"
#include "SoftSerialSendOnry.h"
#include "Milkcocoa.h"
#include "MClient.h"

// The default setting is for the Simple IoT Board(mbed LPC1114FN28)
// Please change to fit the platform
SoftSerialSendOnry pc(dp10); // tx
PwmOut myled(dp18);

/************************* WiFi Access Point *********************************/

#define WLAN_SSID       "...SSID..."
#define WLAN_PASS       "...PASS..."

/************************* Your Milkcocoa Setup *********************************/

#define MILKCOCOA_APP_ID      "...YOUR_MILKCOCOA_APP_ID..."
#define MILKCOCOA_DATASTORE   "LED"

/************* Milkcocoa Setup (you don't need to change this!) ******************/

#define MILKCOCOA_SERVERPORT  1883

/************ Global State (you don't need to change this!) ******************/

// Create an ESP8266 WiFiClient class to connect to the MQTT server.
// The default setting is for the Simple IoT Board(mbed LPC1114FN28)
// Please change to fit the platform
MQTTESP8266 ipstack(dp16,dp15,dp26,WLAN_SSID,WLAN_PASS); // TX,RX,Reset,SSID,Password,Baud
MClient client(&ipstack);

const char MQTT_SERVER[]  = MILKCOCOA_APP_ID ".mlkcca.com";
const char MQTT_CLIENTID[] = __TIME__ MILKCOCOA_APP_ID;

Milkcocoa milkcocoa = Milkcocoa(&client, MQTT_SERVER, MILKCOCOA_SERVERPORT, MILKCOCOA_APP_ID, MQTT_CLIENTID);

extern void onpush(MQTT::MessageData& md);

int main() {
// void setup() {
    pc.baud(9600);
    pc.printf("Milkcocoa mbed ver demo\n\r\n\r\n\r");
    pc.printf("Connecting to %s\n\r",WLAN_SSID);
	milkcocoa.connect();
	pc.printf("\n\rWiFi connected\n\r");
	
	pc.printf("%d\n\r",milkcocoa.on(MILKCOCOA_DATASTORE, "push", onpush));
	
// }
	while(1) {
		milkcocoa.loop();
	}
}

void onpush(MQTT::MessageData& md)
{
    MQTT::Message &message = md.message;
	DataElement de = DataElement((char*)message.payload);
	pc.printf("onpush\n\r");
	myled = (float)de.getInt("RED") / 100.0f;
}